<template>
  <div>
    <h3 class="h4 mb-3">
      Panier <small>({{ cartStore.nbArticles }} produits)</small>
    </h3>
    <table class="recap-table">
      <thead>
        <tr>
          <th>Référence</th>
          <th>Désignation</th>
          <th>Quantité</th>
          <th>Supp.</th>
          <th>Prix unitaire</th>
          <th>Prix total</th>
        </tr>
      </thead>
      <tbody>
        <tr class="tr-responsive" v-for="(item, idx) in cartStore.cart" :key="item.id">
          <td data-label="Référence">{{ item.product.data.titre1 }}</td>
          <td data-label="Désignation">{{ item.product.name }}</td>
          <td data-label="Quantité">
            <b-button size="sm" @click="updateQuantityProduct(item, idx, 'add')" variant="outline-success">+</b-button>
            {{ item.quantity }}
            <b-button size="sm" @click="updateQuantityProduct(item, idx, 'substract')" variant="outline-danger">-</b-button>
          </td>
          <td data-label="Supp.">
            <button class="btn p-0 m-0" @click="deleteToCart(idx)">
              <font-awesome-icon icon="trash-alt" />
            </button>
          </td>
          <td data-label="Prix unitaire">{{ item.product.minPrice | euro }}</td>
          <td data-label="Prix total">{{ item.product.priceByQuant | euro }}</td>
        </tr>

        <!-- A mettre sous conditionnelle étape-->
        <tr class="tr--b-top" v-if="cartStore.remiseCodePromo > 0">
          <td colspan="5" class="text-right td-md"><strong>Remise code promo :</strong></td>
          <td data-label="Sous-total HT">- {{ cartStore.remiseCodePromo | euro }}</td>
        </tr>

        <tr class="tr--b-top">
          <td colspan="5" class="text-right td-md"><strong>Sous-total HT :</strong></td>
          <td data-label="Sous-total HT">{{ cartStore.totalHT | euro }}</td>
        </tr>

        <tr>
          <td colspan="5" class="text-right td-md"><strong>TVA 20% :</strong></td>
          <td data-label="TVA 20%">{{ cartStore.costTVA | euro }}</td>
        </tr>

        <tr v-if="cartStore.delivery.name">
          <td colspan="5" class="text-right td-md">
            <strong>{{ cartStore.delivery.name }} :</strong>
          </td>
          <td :data-label="cartStore.delivery.name">{{ cartStore.delivery.cost | euro }}</td>
        </tr>

        <tr>
          <td colspan="5" class="text-right td-md"><strong>Total TTC :</strong></td>
          <td data-label="Total TTC">
            <strong>{{ cartStore.totalTTC | euro }}</strong>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
// import { cartService } from "@/_services/cart.service";
export default {
  computed: {
    // récupération infos client
    ...mapState({
      cartStore: state => state.cartStore
    })
  },
  data() {
    return {
      // select panier
      quant: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 20, 19, 20],
      show: true,
      form: {
        email: "",
        name: "",
        checked: []
      }
    };
  },
  methods: {
    deleteToCart(idx) {
      this.$store.dispatch("deleteToCart", { index: idx });
    },
    updateQuantityProduct(product, idx, mode) {
      this.$store.dispatch("updateQuantity", { index: idx, quantity: product.quantity, mode: mode });
    }
    // onSubmit(evt) {
    //   evt.preventDefault();
    //   alert(JSON.stringify(this.form));
    // },
    // onReset(evt) {
    //   evt.preventDefault();
    //   // Reset our form values
    //   this.form.email = "";
    //   this.form.name = "";
    //   this.form.quant = null;
    //   this.form.checked = [];
    //   // Trick to reset/clear native browser form validation state
    //   this.show = false;
    //   this.$nextTick(() => {
    //     this.show = true;
    //   });
    // }
  }
};
</script>
